#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import argparse
import os
import _pickle as pickle
import numpy
import tensorflow as tf
import datetime
import dateutil.relativedelta
import time
import subprocess

import tflib
import tflib.linear
import tflib.conv1d

# Color classes to print in bash/shell
class bcolors:
    BLUE   = '\033[94m'
    GREEN  = '\033[92m'
    ORANGE = '\033[93m'
    RED    = '\033[91m'
    ENDC   = '\033[0m'

# Parse command-line arguments
def parse_args():
    parser = argparse.ArgumentParser()
    parser.add_argument('--input',
                        type=str,
                        required=True,                    
                        help='Path to output directory (from previous training eg. /PassGAN/output)')
    parser.add_argument('--model',
                        type=str,
                        required=True,                    
                        help='Path to checkpoint file (eg. /PassGAN/output/saved/model_199000.ckpt)')
    parser.add_argument('--output',
                        type=str,
                        required=True,
                        help='Path to output directory where samples will be stored (eg. /PassGAN/output/samples.txt)')
    parser.add_argument('--amount',
                        type=int,
                        default=1000000,
                        help='Amount of examples to generate (default: 1000000)')
    parser.add_argument('--batch-size',
                        type=int,
                        default=64,
                        help='Batch size, which represents the number of passwords from the training set that propagate through the GAN at each step of the optimizer (default: 64)')
    parser.add_argument('--layer',
                        type=int,
                        default=5,
                        help='Number of residual layers for both the generator and the discriminator (default: 5)')
    parser.add_argument('--dimensionality',
                        type=int,
                        default=128,
                        help='Model dimensionality, which represents the number of dimensions (weights) for each convolutional layer (default: 128)')
    parser.add_argument('--output-length',
                        type=int,
                        default=10,
                        help='Output sequence length, which indicates the maximum length of the strings generated by the generator (default: 10)')
    parser.add_argument('--noise-size',
                        type=int,
                        default=128,
                        help='Size of the input noise vector (seed) which determines how many random bits are fed as input to G for the purpose of generating samples (default: 128)')
    parser.add_argument('--gpu',
                        type=str,
                        default=0,
                        help='Comma-separated list of GPU id\'s to use (default: 0)')
    args = parser.parse_args()
    return args

def softmax(logits, num_classes):
    return tf.reshape(
        tf.nn.softmax(
            tf.reshape(logits, [-1, num_classes])
        ),
        tf.shape(logits)
    )

def ResBlock(name=None, inputs=None, dim=None):
    return inputs + (0.3*tflib.conv1d.Conv1D(name+'.2', dim, dim, 5, tf.nn.relu(tflib.conv1d.Conv1D(name+'.1', dim, dim, 5, tf.nn.relu(inputs)))))

def Generator(noise_size=None, batch_size=None, output_length=None, dimensionality=None, layer=None, output_dim=None):
    if noise_size is None or batch_size is None or output_length is None or dimensionality is None or output_dim is None:
        raise ValueError('One of the arguments was None!')
    output = tf.reshape(tflib.linear.Linear('Generator.Input', 128, output_length * dimensionality, tf.random_normal(shape=[batch_size, noise_size])), [-1, dimensionality, output_length])
    for i in range(1, layer):
        output = ResBlock('Generator.%d' % i, output, dimensionality)
    output = softmax(tf.transpose(tflib.conv1d.Conv1D('Generator.Output', dimensionality, output_dim, 1, output), [0, 2, 1]), output_dim)
    return output

def generate_samples(fake_inputs=None, char_map_inv=None, session=None):
    if fake_inputs is None or char_map_inv is None or session is None:
        raise ValueError('Either fake_inputs, char_map_inv or session were None!')
    
    samples = session.run(fake_inputs)
    samples = numpy.argmax(samples, axis=2)
    decoded_samples = []
    for i in range(0, len(samples)):
        decoded = []
        for j in range(0, len(samples[i])):
            decoded.append(char_map_inv[samples[i][j]])
        decoded_samples.append(tuple(decoded))
    return decoded_samples

def save(samples=None, opath=None, placeholder=None):
    if samples is None or opath is None or placeholder is None:
        raise ValueError('Either samples, opath or placeholder were None!')
    
    with open(opath, 'a') as f:
        f.writelines([str(''.join(sample).replace(placeholder, '') + "\n") for sample in samples])
        
def runThread(args, num, gpu_id):
    if args is None:
        raise ValueError('No arguments supplied!')
    
    # Reset tensorflow and start logger
    os.environ['TF_CPP_MIN_LOG_LEVEL'] = '2'
    
    with tf.device('/cpu:' + gpu_id):
        tf.reset_default_graph()
        
        # Placeholder which is used to stretch passwords generated
        PLACEHOLDER="'"
            
        # Load charmaps
        with open(os.path.join(args.input, 'char_map.pickle'), 'rb') as f:
            char_map = pickle.load(f)
        with open(os.path.join(args.input, 'char_map_inv.pickle'), 'rb') as f:
            char_map_inv = pickle.load(f)

        fake_inputs = Generator(args.noise_size, args.batch_size, args.output_length, args.dimensionality, args.layer, len(char_map))
        
        # Run session and generate samples
        with tf.Session() as session:
            saver = tf.train.Saver()
            saver.restore(session, args.model)
            sample_count = 0
            while sample_count < num:
                #for i in range(0, args.amount // args.batch_size):
                
                samples = generate_samples(fake_inputs, char_map_inv, session)
                samples = [entry for entry in list(set(samples)) if len("".join(entry).replace(PLACEHOLDER, '')) <= args.output_length and len("".join(entry).replace(PLACEHOLDER, '')) >= args.output_length / 2]
                sample_count = sample_count + len(samples)
                while sample_count > num:
                    samples = samples[:-1]
                    sample_count = sample_count - 1
                print("Generated %d%s" % (len(samples), ' ' * 20), end="\r")
                save(samples, args.output, PLACEHOLDER)

def run(args=None):
    if args is None:
        raise ValueError('No arguments supplied!')
    
    gpus = args.gpu.split(',')
    
    from tensorflow.python.client import device_lib
    devices = [x.name.split(':')[-1] for x in device_lib.list_local_devices() if x.device_type == 'GPU']
    
    tmp_gpus = []
    for gpu in gpus:
        if gpu not in devices:
            print("Device #%s not available. Deleting from list." % gpu)
        else:
            tmp_gpus.append(gpu)
    gpus = tmp_gpus
    
    if len(gpus) == 0:
        import sys
        print("No working gpu-id provided. Exiting!")
        sys.exit(1)
    
    if len(gpus) == 1: 
        runThread(args, args.amount, gpus[0])
    else:
        threads = []
        num_per_thread = args.amount // len(gpus)
        count = 1
        for gpu in gpus:
            num_samples = args.amount if (count == len(gpus)) else num_per_thread
            args.amount = args.amount - num_samples
            print("Starting thread on GPU #%s for %d samples" % (gpu, num_samples))
            p = subprocess.Popen([
                                    'env/bin/python3',
                                    'generate.py',
                                    '--input',
                                    str(args.input),
                                    '--model',
                                    str(args.model),
                                    '--output',
                                    str(args.output),
                                    '--amount',
                                    str(num_samples),
                                    '--batch-size',
                                    str(args.batch_size),
                                    '--layer',
                                    str(args.layer),
                                    '--dimensionality',
                                    str(args.dimensionality),
                                    '--output-length',
                                    str(args.output_length),
                                    '--noise-size',
                                    str(args.noise_size),
                                    '--gpu',
                                    str(gpu)
                                 ])
            threads.append(p)
            count = count + 1
        
        while threads:
            if threads[0].poll() is None:
                time.sleep(5)
            else: 
                del threads[0]
    


if __name__ == '__main__':
    start_time = datetime.datetime.fromtimestamp(time.time())
    run(parse_args())
    end_time   = datetime.datetime.fromtimestamp(time.time())
    rd = dateutil.relativedelta.relativedelta (end_time, start_time)
    print("Finished after: %d days, %d hours, %d minutes and %d seconds" % (rd.days, rd.hours, rd.minutes, rd.seconds))
